package ru.dbotthepony.mc.otm.tests

import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.mc.otm.network.FieldSynchronizer
import java.io.ByteArrayInputStream

object FieldSynchronizerTests {
	@Test
	@DisplayName("Field Synchronizer full read/write test")
	fun test() {
		val a = FieldSynchronizer()
		val b = FieldSynchronizer()

		val boolA = a.bool()
		val boolB = b.bool()

		val intA = a.int()
		val intB = b.int()

		val intA2 = a.int()
		val intB2 = b.int()

		val intA3 = a.int()
		val intB3 = b.int()

		boolA.setValue(true)
		intA.setValue(8384)
		intA2.setValue(348488)
		intA3.setValue(-4)

		b.applyNetworkPayload(ByteArrayInputStream(a.collectNetworkPayload()!!.array))

		assertEquals(boolA.getValue(), boolB.getValue())
		assertEquals(intA.getValue(), intB.getValue())
		assertEquals(intA2.getValue(), intB2.getValue())
		assertEquals(intA3.getValue(), intB3.getValue())
	}

	@Test
	@DisplayName("Field Synchronizer partial read/write test")
	fun testPartial() {
		val a = FieldSynchronizer()
		val b = FieldSynchronizer()

		val boolA = a.bool()
		val boolB = b.bool()

		val intA = a.int()
		val intB = b.int()

		val intA2 = a.int()
		val intB2 = b.int()

		val intA3 = a.int()
		val intB3 = b.int()

		boolA.setValue(true)
		//intA.setValue(8384)
		//intA2.setValue(348488)
		intA3.setValue(-4)

		b.applyNetworkPayload(ByteArrayInputStream(a.collectNetworkPayload()!!.array))

		assertEquals(boolA.getValue(), boolB.getValue())
		assertEquals(intA.getValue(), intB.getValue())
		assertEquals(intA2.getValue(), intB2.getValue())
		assertEquals(intA3.getValue(), intB3.getValue())
	}
}
